## Contributing

### Issues

For bug reports, please provide as much useful information as possible to help me identify and fix the problem.

For example, if you are having trouble with the OPML import, please attach a copy of the OPML file you are trying to import.

If you are running a development build of CPod (i.e. you have access to the console) please attach any relevant logs. This is not required but could be very helpful.

### Pull requests

Contributions in the form of pull requests are welcome.

#### Features etc.

Follow the steps in [Install for development](README.md#install-for-development), make changes, and submit a pull request. Please try to follow the code style.

Before writing a new feature and submitting a pull request, please first open an issue to discuss the proposed changes and how they should be added.

#### Translation

Create/open the corresponding language file according to the ISO 639-1 code (e.g. `locales/pt.json`). Optionally include a sub-locale code if the base locale already exists (e.g. `locales/pt_BR.json`). Make changes, and submit a pull request.

Use the `en` locale as the canonical version.
